package groowt.view.component.web.lib

import groowt.view.View
import groowt.view.component.runtime.DefaultComponentWriter

class Render extends DelegatingWebViewComponent {

    private final Object items

    Render(Map attr) {
        if (attr.item && attr.items) {
            throw new IllegalArgumentException("<Render> cannot have both 'item' and 'items' attributes.")
        }
        this.items = attr.item ? [attr.item] : attr.items ?: []
    }

    @Override
    protected View getDelegate() {
        return { Writer w ->
            items.each {
                if (it instanceof Closure) {
                    it = it()
                }
                if (it.respondsTo('renderTo', [Writer] as Class[])) {
                    it.renderTo(w)
                } else if (it.respondsTo('render')) {
                    w << it.render()
                } else {
                    def cw = new DefaultComponentWriter(w, context.renderContext, context)
                    cw << it
                }
            }
        }
    }

}
